/****************************************************************************
PROGRAM: Wdames.c
PURPOSE: Jeu de dames
FUNCTIONS:
WinMain() - calls initialization function, processes message loop
InitApplication() - initializes window data and registers window
InitInstance() - saves instance handle and creates main window
MainWndProc() - processes messages
Remarques :
Les pions dits noirs sont affichs en bleu clair
et les blancs en violet
****************************************************************************/
#include "windows.h"
#include <time.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include "wdames.h"
#include "resource.h"
///////////////////////////////////////////////////////////////////////
// Global variables
///////////////////
long cxClient, cyClient;
clock_t clPause = 300L; //  pause entre deplacements
HCURSOR hArrow, hHour;
HDC TempDC = NULL;
POINT poin ;
RECT rectData =
 {
  29, 29, 411, 411
 }
;
RECT rectPage =
 {
  0, 1000,1000, 0
 }
;
HANDLE hInst;
int tab_pion[10][10] ;            // damier
int eva ,nbre_dep ;
char temp[17] ;
int rc ;
int flag = 9 , sema , gx ,  gy ,zsv = 255, x , y; // flag = 9 fin  2 prise
int FlagCaseActive;               //indique si une case est active ( rouge)
int nbdir ;
int niveau;                        // niveau du jeu
char dep[3] ;
char arr[3] ;
char bestdepl [156] ;              // meilleur chemin
char liste_dep[64][156] ;
char depl1 [19][156] ;
char depl2 [19][156] ;
char depl3 [19][156] ;
char depl4 [19][156] ;
char depl5 [19][156] ;
char depl6 [19][156] ;
char depl7 [19][156] ;
char depl8 [19][156] ;
char depl9 [19][156] ;
char depl10 [19][156] ;
char depl11 [19][156] ;
char depl12 [19][156] ;
char depl13 [19][156] ;
char depl14 [19][156] ;
char depl15 [19][156] ;
char depl16 [19][156] ;
char str[120] ;
char *st ,prem_lig ,seco_lig ;
char depl [19][156] ;
char adr_noir [21][3]=      /* position initiale des noirs */
 {
  /* les dames = pion + 20 */
   {
    "90D"
   }
  ,
   {
    "92D"
   }
  ,
   {
    "94D"
   }
  ,
   {
    "96D"
   }
  ,
   {
    "98D"
   }
  ,
   {
    "81D"
   }
  ,
   {
    "83D"
   }
  ,
   {
    "85D"
   }
  ,
   {
    "87D"
   }
  ,
   {
    "89D"
   } ,
   {
    "70D"
   }
  ,
   {
    "72D"
   }
  ,
   {
    "74D"
   }
  ,
   {
    "76D"
   }
  ,
   {
    "78D"
   }
  ,
   {
    "61D"
   }
  ,
   {
    "63D"
   }
  ,
   {
    "65D"
   }
  ,
   {
    "67D"
   }
  ,
   {
    "69D"
   }
  ,
   {
    "\0\0\0"
   }
 }
;
char adr_blanc[21][3]=   /* position initiale des blancs */
 {
  /* les dames = pion - 20 */
   {
    "01D"
   }
  ,
   {
    "03D"
   }
  ,
   {
    "05D"
   }
  ,
   {
    "07D"
   }
  ,
   {
    "09D"
   }
  ,
   {
    "10D"
   }
  ,
   {
    "12D"
   }
  ,
   {
    "14D"
   }
  ,
   {
    "16D"
   }
  ,
   {
    "18D"
   }
  ,
   {
    "21D"
   }
  ,
   {
    "23D"
   }
  ,
   {
    "25D"
   }
  ,
   {
    "27D"
   }
  ,
   {
    "29D"
   }
  ,
   {
    "30D"
   }
  ,
   {
    "32D"
   }
  ,
   {
    "34D"
   }
  ,
   {
    "36D"
   }
  ,
   {
    "38D"
   }
  ,
   {
    "\0\0\0"
   }
 }
;
char adr_noirsv [10][61];
char adr_blancsv[10][61];
int nbre_prise , rt , lng1 ,dp1;
char flagpb = 0 ,pio ;
int flagbcl , ctrpos , ctrtemp = 0;
char adr_noirini[21][3] =      /* position initiale des noirs */
 {
  /* les dames = pion + 20 */
   {
    "90E"
   }
  ,
   {
    "92F"
   }
  ,
   {
    "94G"
   }
  ,
   {
    "96H"
   }
  ,
   {
    "98I"
   }
  ,
   {
    "81J"
   }
  ,
   {
    "83K"
   }
  ,
   {
    "85L"
   }
  ,
   {
    "87M"
   }
  ,
   {
    "89N"
   }
  ,
   {
    "70O"
   }
  ,
   {
    "72P"
   }
  ,
   {
    "74Q"
   }
  ,
   {
    "76R"
   }
  ,
   {
    "78S"
   }
  ,
   {
    "61T"
   }
  ,
   {
    "63U"
   }
  ,
   {
    "65V"
   }
  ,
   {
    "67W"
   }
  ,
   {
    "69X"
   }
  ,
   {
    "\0\0\0"
   }
 }
;
char adr_blancini [21][3] =   /* position initiale des blancs */
 {
  /* les dames = pion - 20 */
   {
    "010"
   }
  ,
   {
    "031"
   }
  ,
   {
    "052"
   }
  ,
   {
    "073"
   }
  ,
   {
    "094"
   }
  ,
   {
    "105"
   }
  ,
   {
    "126"
   }
  ,
   {
    "147"
   }
  ,
   {
    "168"
   }
  ,
   {
    "189"
   }
  ,
   {
    "21:"
   }
  ,
   {
    "23;"
   }
  ,
   {
    "25<"
   }
  ,
   {
    "27="
   }
  ,
   {
    "29>"
   }
  ,
   {
    "30?"
   }
  ,
   {
    "32@"
   }
  ,
   {
    "34A"
   }
  ,
   {
    "36B"
   }
  ,
   {
    "38C"
   }
  ,
   {
    "\0\0\0"
   }
 }
;
/****************************************************************************
FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)
PURPOSE: calls initialization function, processes message loop
****************************************************************************/
int  PASCAL WinMain(HINSTANCE hInstance,
HINSTANCE hPrevInstance,
LPSTR lpCmdLine,
int  nCmdShow)
 {
  MSG msg;
  if (!hPrevInstance)
  if (!InitApplication(hInstance))
  return (FALSE);
  if (!InitInstance(hInstance, nCmdShow))
  return (FALSE);
  while (GetMessage(&msg, NULL, (UINT)NULL,(UINT)NULL))
   {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
   }
  return (msg.wParam);
 }
/****************************************************************************
FUNCTION: InitApplication(HANDLE)
PURPOSE: Initializes window data and registers window class
****************************************************************************/
BOOL InitApplication(HANDLE hInstance)
 {
  WNDCLASS  wc;
  sema = 1 ;
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = MainWndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(hInstance, "DAMES");
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName =  "MainMenU";
  wc.lpszClassName = "WDamesClass";
  return (RegisterClass(&wc));
 }
/****************************************************************************
FUNCTION:  InitInstance(HANDLE, int)
PURPOSE:  Saves instance handle and creates main window
****************************************************************************/
BOOL InitInstance(HANDLE hInstance, int nCmdShow)
 {
  HWND            hWnd;
  hInst = hInstance;
  hWnd = CreateWindow(
  "WDamesClass",
  "Jeu de Dames",
  WS_OVERLAPPEDWINDOW,
  CW_USEDEFAULT,
  CW_USEDEFAULT,
  CW_USEDEFAULT,
  CW_USEDEFAULT,
  NULL,
  NULL,
  hInstance,
  NULL
  );
  if (!hWnd)
  return (FALSE);
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  return (TRUE);
 }
/****************************************************************************
FUNCTION: MainWndProc(HWND, UINT, UINT, LONG)
PURPOSE:  Processes messages
MESSAGES:
WM_COMMAND    - application menu
WM_CREATE     - create window and objects
WM_PAINT      - update window, draw objects
WM_DESTROY    - destroy window
****************************************************************************/
long WINAPI MainWndProc(HWND hWnd,UINT message, UINT wParam,
LONG lParam)
 {
  HDC hDC;
  FARPROC lpProcAbout;
  FARPROC lpProcAide;
  int xx = 0L ;
  char tabvid[61] = "  D  D  D  D  D  D  D  D  D  D  D  D  D  D  D  D  D  D  D  D" ;
  HMENU menu;
  int  xPos , yPos   ,z , xs;
  switch (message)
   {
    case WM_COMMAND:
     {
      switch(wParam)
       {
        case IDM_FIN:
        DestroyWindow(hWnd);
        return 0;
        case IDM_DEBUT:  /* debut du jeu */
        ctrpos = 0 ; flagbcl = 0 ; ctrtemp = 0;
        flag = 0 ; temp[0] = '\0' ;
        zsv = 255 ;
        flagpb = 0 ;
        rt = 0 ;
        sema = 1 ;
        strcpy (adr_noir[0] , adr_noirini[0]) ;
        strcpy (adr_blanc[0], adr_blancini[0] ) ;
        Affiche(hWnd) ;
        Savepos() ;
        return 0;
        case IDM_POSEPROBLEME:   /* traitement du probleme */
        flag = 0 ; ctrtemp = 0 ; temp[0] = '\0' ;
        zsv = 255 ;
        AfficheDamier(hWnd);
        flagpb = 1 ;  /* indique mode probleme en cours */
        raz_damier() ;
        strcpy(adr_noir[0],tabvid) ;
        strcpy(adr_blanc[0],tabvid) ;
        return 0;
        case IDM_PROBLEMEOK:  /* fin du probleme */
        ctrpos = 0 ; flagbcl = 0 ;
        flagpb = 0 ;
        zsv = 255 ;
        flag = 0; ctrtemp = 0; temp[0] = '\0' ;
        sema = 1 ;
        rt = 0 ;
        Savepos() ;
        return(0) ;
        case IDM_MACHINE: /* la machine joue */
        if (flag == 9) return (0) ;
        flagpb = 0 ;
        if (FlagCaseActive == 1)
         {
          CaseActive(hWnd,x,y,0) ;
          DessinePion ( hWnd ,x,y) ;
          FlagCaseActive = 0 ;
         }
        if (ctrtemp > 0) /* si prise en cours */
         {
          Delsup (hWnd) ; /* on supprime les pions en cours de prise */
         }
        Machine(hWnd) ;   /* la machine joue */
        return 0;
        case IDM_SAVE:
        if (ctrtemp > 0)
         {
          Delsup(hWnd) ;
         }
        storload('w') ;
        return (0) ;
        case IDM_RESTORE:
        storload('r') ;
        flag = 0 ; ctrtemp = 0 ; temp[0] = '\0' ;
        zsv = 255 ;
        flagpb = 0 ;
        ctrpos = 0 ; flagbcl = 0 ;
        rt = 0 ;
        sema = 1 ;
        Affiche(hWnd) ;
        Savepos() ;
        return (0) ;
        case IDM_RECULE:
        flagpb = 0 ;
        zsv = 255 ;
        flag = 0 ; temp[0] = '\0' ; ctrtemp = 0 ;
        rt = 0 ;
        sema = 1 ;
        ctrpos = ctrpos - 1 ;
        if (ctrpos < 0)
         {
          if (flagbcl == 1) ctrpos = 9 ;
          else
          ctrpos = 0 ;
         }
        strcpy (adr_noir[0] , adr_noirsv[ctrpos]) ;
        strcpy (adr_blanc[0], adr_blancsv[ctrpos] ) ;
        Affiche(hWnd) ;
        return 0;
        case IDM_NIVEAU1: // initialize random numbers into abarPerm array
        menu = GetMenu(hWnd);
        CheckMenuItem(menu, IDM_NIVEAU1, MF_CHECKED);
        CheckMenuItem(menu, IDM_NIVEAU2, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU3, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU4, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU5, MF_UNCHECKED);
        niveau = 1 ;
        return 0;
        
		case IDM_NIVEAU2:
        menu = GetMenu(hWnd);
        CheckMenuItem(menu, IDM_NIVEAU2, MF_CHECKED) ;
        CheckMenuItem(menu, IDM_NIVEAU1, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU3, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU4, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU5, MF_UNCHECKED);
        niveau = 2 ;
        return 0;
        
		case IDM_NIVEAU3:
        menu = GetMenu(hWnd);
        CheckMenuItem(menu, IDM_NIVEAU3, MF_CHECKED) ;
        CheckMenuItem(menu, IDM_NIVEAU1, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU2, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU4, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU5, MF_UNCHECKED);  
		niveau = 3 ;
        return 0;

        case IDM_NIVEAU4:
        menu = GetMenu(hWnd);
        CheckMenuItem(menu, IDM_NIVEAU4, MF_CHECKED) ;
        CheckMenuItem(menu, IDM_NIVEAU1, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU2, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU3, MF_UNCHECKED);
		CheckMenuItem(menu, IDM_NIVEAU5, MF_UNCHECKED);
        niveau = 4 ;
        return 0;

		case IDM_NIVEAU5:
        menu = GetMenu(hWnd);
        CheckMenuItem(menu, IDM_NIVEAU5, MF_CHECKED) ;
        CheckMenuItem(menu, IDM_NIVEAU1, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU2, MF_UNCHECKED);
        CheckMenuItem(menu, IDM_NIVEAU3, MF_UNCHECKED);
		CheckMenuItem(menu, IDM_NIVEAU4, MF_UNCHECKED);
        niveau = 5 ;
        return 0;

        case IDM_APROPOS:
        lpProcAbout = MakeProcInstance((FARPROC)About, hInst);
        DialogBox(hInst, "AboutBox", hWnd, lpProcAbout);
        FreeProcInstance(lpProcAbout);
        return 0;
        case IDM_AIDE:
        lpProcAide = MakeProcInstance((FARPROC)Aide, hInst);
        DialogBox(hInst, "AideBox", hWnd, lpProcAide);
        FreeProcInstance(lpProcAide);
        return 0 ;
        // regles() ;
        case IDM_REGLES:
        WinHelp(hWnd,"WDAMES.HLP",HELP_FORCEFILE,xx) ;
        return 0;
        default:
        return (DefWindowProc(hWnd, message, wParam, lParam));
       }
      //switch wParam
     }
    // Case WM_COMMAND
    case WM_CREATE:
    hArrow = LoadCursor(NULL, IDC_ARROW);
    hHour = LoadCursor(NULL, IDC_WAIT);
    menu = GetMenu(hWnd);
    CheckMenuItem(menu, IDM_NIVEAU1, MF_CHECKED);
    niveau = 1 ;
    return 0;
    case WM_PAINT:
     {
      rt = 0 ;
      Affiche(hWnd);
      return 0;
     }
    case WM_DESTROY:
    PostQuitMessage(0);
    return 0;
    case WM_RBUTTONDOWN:
    if (flag == 9) return (0) ;
    if (flagpb == 1)
     {
      xPos = LOWORD(lParam);
      hDC = GetDC(hWnd);
      SetMapMode(hDC, MM_ISOTROPIC);
      // SetWindowExt(hDC, rectPage.right, rectPage.top);
      SetWindowExtEx(hDC, 640, 440 , NULL);
      SetViewportExtEx(hDC, cxClient, cyClient,NULL); // Set up Window
      SetViewportOrgEx (hDC, 0, 0 , NULL);
      yPos = HIWORD(lParam);
      poin.x = xPos ;
      poin.y = yPos ;
      DPtoLP(hDC,&poin,1);
      ReleaseDC(hWnd, hDC);
      xPos = poin.x;
      yPos = poin.y;
      if ((xPos < 30) || (xPos > 410 )
      || (yPos < 30) || (yPos > 410 ) ) return 0 ;
      x = (xPos - 30) / 38 ;
      y = (yPos - 30) / 38 ;
      if ((( x%2 == 0) && (y%2 == 0)) ||
      (( y%2 == 1) && (x%2 == 1))) return 0 ;
      arr [0] = y+48 ;
      arr [1] = x+48 ;
      arr [2] = '\0' ;
      Problem (arr,'G') ;
      EffacePion(hWnd,x,y) ;
      DessinePion(hWnd,x,y);
      return 0;
     }
    return 0;
    case WM_LBUTTONDOWN:
    if (flag == 9) return (0) ;  // la partie est finie
    xPos = LOWORD(lParam);
    yPos = HIWORD(lParam);
    hDC = GetDC(hWnd);
    SetMapMode(hDC, MM_ISOTROPIC);
    // SetWindowExt(hDC, rectPage.right, rectPage.top);
    SetWindowExtEx(hDC, 640, 440 ,NULL);
    SetViewportExtEx(hDC, cxClient, cyClient,NULL); // Set up Window
    SetViewportOrgEx (hDC, 0, 0,NULL);
    poin.x = xPos ;
    poin.y = yPos ;
    DPtoLP(hDC,&poin,1);
    ReleaseDC(hWnd, hDC);
    xPos = poin.x;
    yPos = poin.y;
    if ((xPos < 30) || (xPos > 410 )
    || (yPos < 30) || (yPos > 410 ) ) return 0 ; // out du damier
    x = (xPos - 30) / 38 ;
    y = (yPos - 30) / 38 ;
    if ((( x%2 == 0) && (y%2 == 0)) ||
    (( y%2 == 1) && (x%2 == 1))) return 0 ;
    arr [0] = y+48 ;
    arr [1] = x+48 ;
    arr [2] = '\0' ;
    if (flagpb == 1)
     {
      // on est en mode probleme
      Problem (arr,'D') ;
      EffacePion(hWnd,x,y) ;
      DessinePion(hWnd,x,y);
      return 0;
     }
    if (sema == 0)  // on clic sur une position arrive
     {
      /*-------- On interdit les dplacement incorrects --------------*/
      if ( check (dep,arr,rt) > 0)
       {
        // il y a une erreur
        FlagCaseActive = 0 ;
        CaseActive(hWnd , gx , gy , sema) ;
        DessinePion(hWnd,gx,gy);
        sema = 1 ;               // le prochain clic sera sur une
        // position de depart
        if (tab_pion[y][x] > 'D') goto eti ; // si arrive = pion noir
        // on estime que c'est une pos de dep
        Ecrit(hWnd,"Incorrect !!!         ") ;// sinon message
        Beep(2500,80);
        return (0) ;                            // et beep
       }
      /* la position arrive est ok */
      Ecrit(hWnd,"                      ") ;   // raz message
      EffacePion(hWnd,gx,gy) ;
      DessinePion(hWnd,x,y);
      if (flag == 0)   // si pas de prise en cours
       {
        if (ctrpos > 9)
         {
          ctrpos = 0 ;
          flagbcl = 1 ;
         }
        Savepos() ;   // on sauvegarde la pos courante
        ctrpos = ctrpos + 1 ;
       }
      if (eva == 9)  flag = 2; // si prise flag = 2
      lng1 = strlen(bestdepl) ;
      for (dp1=0;dp1 < lng1;dp1+=5)
       {
        depl_n(&bestdepl[dp1+1],&bestdepl[dp1+3]);
        if (bestdepl[dp1] != 'D')
         {
          // si prise
          z = sup2_bla(bestdepl[dp1]) ;
          pionsaute(bestdepl[dp1],'B');
          temp[ctrtemp] = bestdepl[dp1] ; // on sauvegarde les pions sautes
          ctrtemp +=1 ;
          temp[ctrtemp] = '\0' ; ;  // fin de chaine
          ModifiePion(hWnd,gy,gx,0) ;
         }
       }
      z = tab_pion[arr[0]-48][arr[1]-48] ; // z = pion sur case arrivee
      if (z >= 89) z = z - 89 ;
      else z = z - 69 ;
      xs = chkpris(z) ; // xs indique si ce pion peut prendre ou non
      if ((xs == 0) || (flag != 2)) // si pas eu de prise
       {
        rt = testd_n(arr) ;   // arrivee a dame ?
        if (rt == 1)        // oui
         {
          pio = adr_noir[z][2] -20 ;  // on transforme en dame
         }
       }
      DessinePion(hWnd,x,y);
      if (flag == 2)  // il y a eu prise
       {
        if (xs == 9)  // et il y a un pion a prendre
         {
          zsv = z ;   // on sauvegarde ce pion
          sema = 1 ;
          return (0) ;
         }
       }
      lng1 = strlen(temp) ;
      if (lng1 > 0)
       {
        Delsup(hWnd) ;
       }
      flag = 0 ;
      zsv = 255 ; // reinitialise zsv
      rt = 0 ;
      Machine(hWnd) ;
      sema = 1 ;
     }
    else   // on clique sur un pion depart
     {
      eti :
      dep [0] = y+48 ;
      dep [1] = x+48 ;
      dep [2] = '\0' ;
      gy = y ;
      gx = x ;
      z = tab_pion[dep[0]-48][dep[1]-48] ;
      if (z >= 89) z = z - 89 ;
      else z = z - 69 ;
      if ((zsv < 255) && (z != zsv)) return(0) ; // incorrect prise en cours
      // on ne peut jouer que le
      // pion qui a deja pris (zsv)
      if (tab_pion[y][x] > 'D')   /* la case contient un element noir ok*/
       {
        FlagCaseActive = 1 ;  // il y a une case active
        CaseActive(hWnd , x , y , sema) ; // on active la case (passe en rouge)
        DessinePion (hWnd , x , y) ;
        sema = 0 ;
       }
     }
    return 0;
    default:
    return (DefWindowProc(hWnd, message, wParam, lParam));
   }
  return 0;
 }
//Cercle: dessine un cercle sur la fenetre
void DessinePion(HWND hWnd,int x , int y )
 {
  HDC hDC;                          /* display-context variable  */
  int a , b ;
  HBRUSH  hNewBarBrush, hOldBarBrush ;
  if (tab_pion [y][x] == 'D') return ;
  // recuperer le display-context
  hDC = GetDC(hWnd);
  SetMapMode(hDC, MM_ISOTROPIC);
  // SetWindowExt(hDC, rectPage.right, rectPage.top);
  SetWindowExtEx(hDC, 640, 440 , NULL);
  SetViewportExtEx(hDC, cxClient, cyClient , NULL); // Set up Window
  SetViewportOrgEx (hDC, 0, 0 , NULL);
  // Create and select the brush to draw the chart data itself
  if (tab_pion [y][x] > 'D')
  hNewBarBrush = CreateSolidBrush(RGB(0,255,255));
  else
  hNewBarBrush = CreateSolidBrush(RGB(255,0,255));
  hOldBarBrush =  SelectObject(hDC, hNewBarBrush);
  a = 33 + (x*38) ;
  b = 33  + (y*38) ;
  Ellipse (hDC, a,b, a+32,b+32 );
  // Delete the brush, after selecting the old one back in the DC.
  //
  SelectObject(hDC, hOldBarBrush);
  DeleteObject(hNewBarBrush);
  if ((tab_pion [y][x] > 'X') || (tab_pion [y][x] < '0'))
   {
    a = 44 + (x*38) ;
    b = 44  + (y*38) ;
    hNewBarBrush = CreateSolidBrush(RGB(255,0,0));
    hOldBarBrush =  SelectObject(hDC, hNewBarBrush);
    Ellipse (hDC, a,b, a+10,b+10 );
    SelectObject(hDC, hOldBarBrush);
    DeleteObject(hNewBarBrush);
   }
  ReleaseDC(hWnd, hDC);
  hDC = NULL;
 }
//CaseActive : change la couleur d ' une case
void CaseActive(HWND hWnd , int x , int y, int sema)
 {
  HDC hDC;                          /* display-context variable  */
  HBRUSH hNewBarBrush, hOldBarBrush ;
  // recuperer le display-context
  hDC = GetDC(hWnd);
  SetMapMode(hDC, MM_ISOTROPIC);
  SetWindowExtEx(hDC, 640, 440 , NULL);
  SetViewportExtEx(hDC, cxClient, cyClient, NULL); // Set up Window
  SetViewportOrgEx (hDC, 0, 0 , NULL);
  // Create and select the brush to draw the chart data itself
  /* fond noir */
  if (sema == 1 )
  hNewBarBrush = CreateSolidBrush(RGB(255,0,0));
  else
  hNewBarBrush = CreateSolidBrush(RGB(0,0,0));
  hOldBarBrush =  SelectObject(hDC, hNewBarBrush);
  x = 30 + (x*38) ;
  y = 30 + (y*38) ;
  Rectangle (hDC,x,y,x+38,y+38 ) ;
  // Delete the brush, after selecting the old one back in the DC.
  //
  SelectObject(hDC, hOldBarBrush);
  DeleteObject(hNewBarBrush);
  ReleaseDC(hWnd, hDC);
  hDC = NULL;
 }
//ModifiePion : change la couleur d ' une case
void ModifiePion(HWND hWnd , int x , int y,int typ)
 {
  int a , b, i ,j ,k ;
  HDC hDC;                          /* display-context variable  */
  HBRUSH hNewBarBrush, hOldBarBrush ;
  // recuperer le display-context
  if (typ == 1 )
   {
    i = 255;j =255 ; k = 255 ;
   }
  else
   {
    i = 200;j =200 ; k = 200 ;
   }
  hDC = GetDC(hWnd);
  SetMapMode(hDC, MM_ISOTROPIC);
  SetWindowExtEx(hDC, 640, 440 , NULL);
  SetViewportExtEx(hDC, cxClient, cyClient, NULL); // Set up Window
  SetViewportOrgEx (hDC, 0, 0 , NULL);
  // Create and select the brush to draw the chart data itself
  hNewBarBrush = CreateSolidBrush(RGB(i,j,k));
  hOldBarBrush =  SelectObject(hDC, hNewBarBrush);
  a = 33 + (x*38) ;
  b = 33  + (y*38) ;
  Ellipse (hDC, a,b, a+32,b+32 );
  // Delete the brush, after selecting the old one back in the DC.
  //
  SelectObject(hDC, hOldBarBrush);
  DeleteObject(hNewBarBrush);
  ReleaseDC(hWnd, hDC);
  hDC = NULL;
 }
//EffacePion: efface un pion
void EffacePion(HWND hWnd , int x , int y)
 {
  HDC hDC;                          /* display-context variable  */
  HBRUSH
  hNewBarBrush, hOldBarBrush ;
  // recuperer le display-context
  hDC = GetDC(hWnd);
  SetMapMode(hDC, MM_ISOTROPIC);
  SetWindowExtEx(hDC, 640,440 , NULL);
  SetViewportExtEx(hDC, cxClient, cyClient,NULL); // Set up Window
  SetViewportOrgEx (hDC, 0, 0 , NULL);
  // Create and select the brush to draw the chart data itself
  /* fond noir */
  hNewBarBrush = CreateSolidBrush(RGB(0,0,0));
  hOldBarBrush =  SelectObject(hDC, hNewBarBrush);
  x = 30 + (x*38) ;
  y = 30 + (y*38) ;
  Rectangle (hDC,x,y,x+38,y+38 ) ;
  // Delete the brush, after selecting the old one back in the DC.
  //
  SelectObject(hDC, hOldBarBrush);
  DeleteObject(hNewBarBrush);
  ReleaseDC(hWnd, hDC);
  hDC = NULL;
 }
//AfficheDamier: Affichage du damier on the window
void AfficheDamier(HWND hWnd)
 {
  HDC hDC;                          /* display-context variable  */
  PAINTSTRUCT ps;                   /* paint structure           */
  int x , y , i , j ;
  HPEN hWhitePen, hOldPen;
  HBRUSH hNewBrush, hOldBrush;
  InvalidateRect(hWnd, NULL, TRUE); //invalidate entire window
  hDC = BeginPaint(hWnd, &ps);
  cxClient = ps.rcPaint.right - ps.rcPaint.left;
  cyClient = ps.rcPaint.bottom - ps.rcPaint.top;
  //  hDC = GetDC(hWnd);
  SetMapMode(hDC, MM_ISOTROPIC);
  // SetWindowExt(hDC, rectPage.right, rectPage.top);
  SetWindowExtEx(hDC, 640, 440 , NULL);
  SetViewportExtEx(hDC, cxClient, cyClient,NULL); // Set up Window
  SetViewportOrgEx (hDC, 0, 0, NULL);
  // recuperer le display-context
  hWhitePen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
  hOldPen = SelectObject(TempDC, hWhitePen);
  Rectangle(hDC, rectData.left,rectData.top, rectData.right, rectData.bottom );
  SelectObject(TempDC, hOldPen);
  DeleteObject(hWhitePen);
  // Create and select the brush to draw the chart data itself
  hNewBrush = CreateSolidBrush(RGB(255,255,0));
  hOldBrush =  SelectObject(hDC, hNewBrush);
  Rectangle (hDC, 30,30, 30+380,30+380);      /* fond clair */
  SelectObject(hDC, hOldBrush);
  DeleteObject(hNewBrush);
  hNewBrush = CreateSolidBrush(RGB(0,0,0));
  hOldBrush =  SelectObject(hDC, hNewBrush);
  for (i = 0 ; i < 10 ; i++)
   {
    for (j = 0 ; j < 10 ; j++)
     {
      if ((( i%2 == 0) && (j%2 == 1)) ||
      (( i%2 == 1) && (j%2 == 0)))
       {
        x = 30 + (j*38) ;
        y = 30 + (i*38) ;
        Rectangle (hDC,x,y,x+38,y+38 ) ;
       }
     }
   }
  // Delete the brush, after selecting the old one back in the DC.
  //
  SelectObject(hDC, hOldBrush);
  DeleteObject(hNewBrush);
  EndPaint (hWnd, &ps);
  ReleaseDC(hWnd, hDC);
  hDC = NULL;
 }
void Ecrit(HWND hWnd,char *chaine)
 {
  HDC hDC;                          /* display-context variable  */
  char text [50] ;
  sprintf(text, "%s", chaine);
  hDC = GetDC(hWnd);
  SetMapMode(hDC, MM_ISOTROPIC);
  // SetWindowExt(hDC, rectPage.right, rectPage.top);
  SetWindowExtEx(hDC, 640, 440 , NULL);
  SetViewportExtEx(hDC, cxClient, cyClient , NULL); // Set up Window
  SetViewportOrgEx (hDC, 0, 0 , NULL);
  // Print the number of seconds elapsed
  TextOut(hDC, 420, 30, text, strlen(text));
  ReleaseDC(hWnd, hDC);
  return ;
 }
// Bep: Sounds the speaker for a time specified in microseconds by
// duration at a pitch specified in hertz by frequency.
//
void Bep( int frequency, int duration )
 {
  int control;
  // If frequency is 0, Beep doesn't try to make a sound. It
  // just sleeps for the duration.
  if( frequency )
   {
    // 75 is about the shortest reliable duration of a sound.
    if( duration < 75 )
    duration = 75;
    // Prepare timer by sending 10111100 to port 43.
    _outp( 0x43, 0xb6 );
    // Divide input frequency by timer ticks per second and
    // write (byte by byte) to timer.
    frequency = (unsigned)(1193180L / frequency);
    _outp( 0x42, (char)frequency );
    _outp( 0x42, (char)(frequency >> 8) );
    // Save speaker control byte.
    control = _inp( 0x61 );
    // Turn on the speaker (with bits 0 and 1).
    _outp( 0x61, control | 0x3 );
   }
  Slep( (clock_t)duration );
  // Turn speaker back on if necessary.
  if( frequency )
  _outp( 0x61, control );
 }
// InitPrevRandom: initializes abarWork to previous random values and
// repaints random display
void InitPrevRandom(HWND hWnd)
 {
  AfficheDamier(hWnd);
 }
void Savepos (void)
 {
  strcpy(adr_blancsv[ctrpos],adr_blanc[0]) ; /*  on sauvegarde les  */
  strcpy(adr_noirsv[ctrpos],adr_noir[0]) ;   /* adresses pour recule un coup */
  return ;
 }
void Machine(HWND hWnd)
 {
  int i ;
  Ecrit(hWnd,"Evaluation en cours       ") ;
  SetCursor(hHour);
  Slep(clPause/2) ;
  bestdepl[0] = '\0' ;
  rc = evalue () ; // evaluation
  if ((rc <= -200) && (bestdepl[0] == '\0') )
   {
    Ecrit(hWnd,"La machine a perdu") ;
    flag = 9 ;
    return  ;
   }
  if ((rc >= 200) && (bestdepl[0] == '\0') ) // gain : les noirs ne peuvent jouer
   {
    Ecrit(hWnd,"La machine a gagn") ;
    flag = 9 ;
    return  ;
   }
  Ecrit(hWnd,"                                           ") ;
  lng1 = strlen(bestdepl) ;
  for (dp1=0;dp1 < lng1;dp1+=5)
   {
    x = bestdepl[dp1+2] - 48 ;
    y = bestdepl[dp1+1] - 48 ;
    CaseActive(hWnd,x,y,1);
    DessinePion(hWnd,x,y);
    if (dp1 == 0) Slep(clPause) ;
    Slep(clPause/2);
    EffacePion(hWnd,x,y);
    depl_b(&bestdepl[dp1+1],&bestdepl[dp1+3]);
    if (bestdepl[dp1] != 'D')
     {
      x = sup_noir(bestdepl[dp1]) ;
      pionsaute(bestdepl[dp1],'N');
      ModifiePion(hWnd,gy,gx,0) ;
      Slep(clPause/2) ;
      x = bestdepl[dp1+4] - 48 ;
      y = bestdepl[dp1+3] - 48 ;
      DessinePion(hWnd,x,y);
      if (dp1 < lng1 - 6 ) Slep(clPause/2) ;
     }
   }
  i= testd_b(&bestdepl[lng1-2]) ;
  x = bestdepl[lng1-1] - 48 ;
  y = bestdepl[lng1-2] - 48 ;
  DessinePion(hWnd,x,y);
  SetCursor(hArrow);
  Slep(clPause) ;
  for (dp1=0;dp1 < lng1;dp1+=5)
   {
    if (bestdepl[dp1] != 'D')
     {
      pionsaute(bestdepl[dp1],'N');
      EffacePion(hWnd,gy,gx) ;
     }
   }
  if (rc >= 200)
   {
    Ecrit(hWnd,"La machine a gagn") ; // gain mais les noirs peuvent jouer
    flag = 9 ;
   }
  sema = 1 ;
  temp[0] = '\0' ;
  ctrtemp = 0 ;
  return ;
 }
void Delsup(HWND hWnd)
 {
  int z ;
  for (dp1=0;dp1 < lng1;dp1+=1)
   {
    z = sup_blan(temp[dp1]) ;
    pionsaute(temp[dp1],'B');
    EffacePion(hWnd,gy,gx) ;
   }
  return ;
 }
void Affiche(HWND hWnd)
 {
  int i ;
  init_damier();
  AfficheDamier(hWnd);
  for (i = 0 ; i < 20 ; i++)
   {
    DessinePion (hWnd, adr_noir[i][1] -48 ,adr_noir[i][0] -48  ) ;
    DessinePion (hWnd, adr_blanc[i][1] -48 ,adr_blanc[i][0] -48  ) ;
   }
  return ;
 }
/****************************************************************************
FUNCTION: About(HWND, unsigned, WORD, LONG)
PURPOSE:  Processes messages for "About" dialog box
MESSAGES:
WM_INITDIALOG - initialize dialog box
WM_COMMAND    - Input received
****************************************************************************/
BOOL WINAPI About(HWND hDlg, unsigned message,WORD wParam,LONG lParam)
 {
  switch (message)
   {
    case WM_INITDIALOG:
    return (TRUE);
    case WM_COMMAND:
    if (wParam == IDOK
    || wParam == IDCANCEL)
     {
      EndDialog(hDlg, TRUE);
      return (TRUE);
     }
    break;
   }
  return (FALSE);
 }
//
/****************************************************************************
FUNCTION: Regles(HWND, unsigned, WORD, LONG)
PURPOSE:  Processes messages for "Regles" dialog box
MESSAGES:
WM_INITDIALOG - initialize dialog box
WM_COMMAND    - Input received
****************************************************************************/
BOOL WINAPI Aide(HWND hDlg,unsigned message,WORD wParam,LONG lParam)
 {
  switch (message)
   {
    case WM_INITDIALOG:
    return (TRUE);
    case WM_COMMAND:
    if (wParam == IDC_OK || wParam == IDCANCEL)
     {
      EndDialog(hDlg, TRUE);
      return (TRUE);
     }
    break;
   }
  return (FALSE);
 }
